'================================================================================================
' (c)2014 PIC18F2550
'================================================================================================
' Configurator der benötigten Module
'================================================================================================
'================================================================================================
#define KN001       ' Kartentyp VGA6+2+Keyb+Maus
#ifdef  KN001
#define KN001_000   ' Software  TEXT  640x480, 69Hz,  80x40 characters, 8x12 ext. Font 0-255, 16/16 Color
'#define KN001_001   ' Software  TEXT  800x600, 75Hz, 100x50 characters, 8x12 ext. Font 0-255, 16/16 Color
'#define KN001_002   ' Software  TEXT 1024x768, 57Hz, 128x64 characters, 8x12 ext. Font 0-255, 16/16 Color
#define KN001_xxx_000 ' Standart Zeichensatz Deutsch
'#define KN001_xxx_001 ' Zeichensatz Englisch
'#define KN001_xxx_002 ' Zeichensatz Französisch
'#define KN001_xxx_003 ' Zeichensatz Spanisch
'#define KN001_xxx_004 ' Zeichensatz
'#define KN001_xxx_005 ' Zeichensatz
#endif
'================================================================================================
#define KN002       ' 
#ifdef KN002
#endif
'================================================================================================
#define KN003       ' 
#ifdef KN003
#endif
'================================================================================================
#define KN004       ' 
#ifdef KN004
#endif
'================================================================================================


'================================================================================================
' Stantard Modul
'================================================================================================
#include "KNxxx.spin"          ' Commandos & Konstanten
#include "comand.spin"          ' Commandos & Konstanten

PUB main | index, spec, slot, cmd, a
''kommandointerpreter
''funktionsgruppe               : chip
''funktion                      : kommandointerpreter
''eingabe                       : -
''ausgabe                       : -
  repeat 800_000
  s_PCA9995_INIT
  spec  := s_PCA9995_READ        ' über I²C den Steckplatz ermitteln
  slot  := spec and h_SLOT
  spec  := spec and h_SPEC
  index := spec and h_Kindex
  spec  := spec > 5
  s_PCA9995_WRITE(1,1,1,1)      'rote & grüne LED an -> gelb
  repeat
#ifdef 16BIT
    waitpeq (ina, h_IOWR + h_CBUS, 0)
    cmd := ina[h_BUS]           'kommandocode empfangen
#endif
#ifdef 8BIT
#endif
    case cmd AND $1FFC0
      c_SYS : 
        case cmd
          index + c_SYS_SPEC        : s_SYS_QUIT
                                      s_SYS_SPEC
          index + c_SYS_COGS        : s_SYS_QUIT
                                      s_SYS_COGS
          index + c_SYS_LOAD        : s_SYS_QUIT
                                      s_SYS_LOAD
          index + c_SYS_LEDON       : s_SYS_QUIT
                                      s_SYS_LEDON
          index + c_SYS_LEDOFF      : s_SYS_QUIT
                                      s_SYS_LEDOFF
          index + c_SYS_REBO0T      : s_SYS_QUIT
                                      s_SYS_REBO0T
'================================================================================================
' Modul Sprungverteiler
'================================================================================================
#include "VGA_TEXT_s.spin"
'#include "VGA_GRAPH_s.spin"
'#include "fat32_s.spin" 

'================================================================================================
'
'================================================================================================
PRI s_PCA9995_INIT
   outa[h_SCL] := 1                       'Drive SCL high.
   dira[h_SCL] := 1
   dira[h_SDA] := 0                       'Set SDA as input
   repeat 9
      outa[h_SCL] := 0                    'Put out up to 9 clock pulses
      outa[h_SCL] := 1
      if ina[h_SDA]                       'Repeat if SDA not driven high
         quit                             'by the I2C Device
' Send IO config
  return

'================================================================================================
'
'================================================================================================
PRI s_PCA9995_READ
  return

'================================================================================================
'
'================================================================================================
PRI s_PCA9995_WRITE(a,b,c,d) | e
  e := s_PCA9995_READ
  if a == 1               ' Rote LED
    if b == 1             ' Rote LED Aus
      e := e and h_LED_ROT
    else                  ' Rote LED An
      e := e or h_LED_ROT
  if c == 1               ' Grüne LED
    if d == 1             ' Grüne LED Aus
      e := e and h_LED_GRUEN
    else                  ' Grüne LED An
      d := e or h_LED_GRUEN
' Ausgabe 

  return

'================================================================================================
'
'================================================================================================
PUB IN(address):data | ackbit  ''Read PCF8574 Inputs. Automatically sets all pins to HIGH.
''Remember to Reset Outputs after calling

    OUT(address, %11111111)
    START
    ackbit:=Write((address<<1)+1)
    if (ackbit==h_ACK)
      data:=Read(h_ACK)
    else
      data:=-1   'return negative to indicate read failure
    STOP
    return data
    

'================================================================================================
'
'================================================================================================
PUB OUT(address,data):ackbit ''Write PCF8574 Outputs.
   START
   ackbit:=Write(address<<1)
   ackbit := (ackbit << 1) | Write(data)
   STOP
   return (ackbit==h_ACK)

'================================================================================================
'
'================================================================================================
PRI Start                              ' SDA goes HIGH to LOW with SCL HIGH
   outa[h_SCL]~~                       ' Initially drive SCL HIGH
   dira[h_SCL]~~
   outa[h_SDA]~~                       ' Initially drive SDA HIGH
   dira[h_SDA]~~
   outa[h_SDA]~                        ' Now drive SDA LOW
   outa[h_SCL]~                        ' Leave SCL LOW
  
'================================================================================================
'
'================================================================================================
PRI Stop                               ' SDA goes LOW to HIGH with SCL High
   outa[h_SCL]~~                       ' Drive SCL HIGH
   outa[h_SDA]~~                       '  then SDA HIGH
   dira[h_SCL]~                        ' Now let them float
   dira[h_SDA]~                        ' If pullups present, they'll stay HIGH

'================================================================================================
'
'================================================================================================
PRI Write(data) : ackbit
'' Write i2c data.  Data byte is output MSB first, SDA data line is valid
'' only while the SCL line is HIGH.  Data is always 8 bits (+ ACK/NAK).
'' SDA is assumed LOW and SCL and SDA are both left in the LOW state.
   ackbit := 0 
   data <<= 24
   repeat 8                              ' Output data to SDA
      outa[h_SDA] := (data <-= 1) & 1
      outa[h_SCL]~~                      ' Toggle SCL from LOW to HIGH to LOW
      outa[h_SCL]~
   dira[h_SDA]~                          ' Set SDA to input for ACK/NAK
   outa[h_SCL]~~
   ackbit := ina[h_SDA]                  ' Sample SDA when SCL is HIGH
   outa[h_SCL]~
   outa[h_SDA]~                          ' Leave SDA driven LOW
   dira[h_SDA]~~

'================================================================================================
'
'================================================================================================
PRI Read(ackbit):data
'' Read in i2c data, Data byte is output MSB first, SDA data line is
'' valid only while the SCL line is HIGH.  SCL and SDA left in LOW state.
   data := 0
   dira[h_SDA]~                          ' Make SDA an input
   repeat 8                              ' Receive data from SDA
      outa[h_SCL]~~                      ' Sample SDA when SCL is HIGH
      data := (data << 1) | ina[h_SDA]
      outa[h_SCL]~
   outa[h_SDA] := ackbit                 ' Output ACK/NAK to SDA
   dira[h_SDA]~~
   outa[h_SCL]~~                         ' Toggle SCL from LOW to HIGH to LOW
   outa[h_SCL]~
   outa[h_SDA]~                          ' Leave SDA driven LOW







'================================================================================================
'
'================================================================================================
PRI s_SYS_QUIT
  outa[h_QT] := 0
  dira[h_QT] := 1

  dira[h_QT] := 0
  return

'================================================================================================
'
'================================================================================================
PRI s_SYS_GETDATA
  return

'================================================================================================
'
'================================================================================================
PRI s_SYS_PUTDATA
  return

'================================================================================================
'
'================================================================================================
PRI s_SYS_GETSPEC
  return

'================================================================================================
'
'================================================================================================
PRI s_SYS_GETCOGS
  return

'================================================================================================
'
'================================================================================================
PRI s_SYS_SPEC
  return

'================================================================================================
'
'================================================================================================
PRI s_SYS_COGS
  return

'================================================================================================
'
'================================================================================================
PRI s_SYS_LOAD
  return
DAT
                        org     0

a_SYS_LOAD
                        mov     outa,    M_0               'bus inaktiv
                        mov     dira,    DINP              'bus auf eingabe schalten
                        mov     reg_a,   PAR               'parameter = plen
                        mov     reg_b,   #0                'adresse ab 0

                        ' datenblock empfangen
loop
                        call    #get                       'wert einlesen
                        wrbyte  inp,     reg_b             'wert --> hubram
                        add     reg_b,   #1                'adresse + 1
                        djnz    reg_a,   #loop

                        ' neuen code starten

                        rdword  reg_a,   #$A               ' Setup the stack markers.
                        sub     reg_a,   #4                '
                        wrlong  SMARK,   reg_a             '
                        sub     reg_a,   #4                '
                        wrlong  SMARK,   reg_a             '

                        rdbyte  reg_a,   #$4               ' Switch to new clock mode.
                        clkset  reg_a                                             '

                        coginit SINT                       ' Restart running new code.


                        cogid   reg_a
                        cogstop reg_a                      'cog hält sich selbst an


get
                        waitpeq M_1,      M_2              'busclk=1? & /cs=0?
                        mov     inp,      ina              'daten einlesen
                        and     inp,      DMASK            'wert maskieren
                        mov     outa,     M_3              'hs=0
                        waitpeq M_3,      M_4              'busclk=0?
                        mov     outa,     M_0              'hs=1
get_ret                 ret


'     hbeat   --------+
'     clk     -------+|
'     /wr     ------+||
'     /hs     -----+|||+------------------------- /cs
'                  |||||                 -------- d0..d7
DINP    long  %00001001000000000000000000000000  'constant dinp hex  \ bus input
DOUT    long  %00001001000000000000000011111111  'constant dout hex  \ bus output

M_0     long  %00001000000000000000000000000000  'bus inaktiv

M_1     long  %00000010000000000000000000000000
M_2     long  %00000010100000000000000000000000  'busclk=1? & /cs=0?

M_3     long  %00000000000000000000000000000000
M_4     long  %00000010000000000000000000000000  'busclk=0?


DMASK   long  %00000000000000000000000011111111  'datenmaske

SINT    long    ($0001 << 18) | ($3C01 << 4)                       ' Spin interpreter boot information.
SMARK   long    $FFF9FFFF                                          ' Stack mark used for spin code.

inp     res   1
reg_a   res   1
reg_b   res   1

'================================================================================================
'
'================================================================================================
PRI s_SYS_LEDON
  s_PCA9995_WRITE(0,0,1,1)      'grüne LED an
  return

'================================================================================================
'
'================================================================================================
PRI s_SYS_LEDOFF
  s_PCA9995_WRITE(0,0,1,0)      'grüne LED aus
  return

'================================================================================================
'
'================================================================================================
PRI s_SYS_REBO0T
  reboot

'================================================================================================
'
'================================================================================================
#include "VGA_TEXT.spin"
'#include "VGA_GRAPH.spin"
'#include "fat32.spin"