'================================================================================================
' (c)2014 PIC18F2550
'================================================================================================
#ifdef KN001_000  ' VGA TEXT  640x480, 69Hz,  80x40 characters, 8x12 ext. Font 0-255, 16/16 Color
CON
  c_VGA_HP = 640      'horizontal pixels
  c_VGA_VP = 480      'vertical pixels
  c_VGA_HF = 24       'horizontal front porch pixels
  c_VGA_HS = 40       'horizontal sync pixels
  c_VGA_HB = 128      'horizontal back porch pixels
  c_VGA_VF = 9        'vertical front porch lines
  c_VGA_VS = 3        'vertical sync lines
  c_VGA_VB = 28       'vertical back porch lines
  c_VGA_HN = 1        'horizontal normal sync state (0|1)
  c_VGA_VN = 1        'vertical normal sync state (0|1)
  c_VGA_PR = 30       'pixel rate in MHz at 80MHz system clock (5MHz granularity)
  COLS = c_VGA_HP / 8
  ROWS = c_VGA_VP / 12
#endif
#ifdef KN001_001  ' VGA TEXT  800x600, 75Hz, 100x50 characters, 8x12 ext. Font 0-255, 16/16 Color
CON  
  c_VGA_HP = 800      'horizontal pixels
  c_VGA_VP = 600      'vertical pixels
  c_VGA_HF = 40       'horizontal front porch pixels
  c_VGA_HS = 128       'horizontal sync pixels
  c_VGA_HB = 188      'horizontal back porch pixels
  c_VGA_VF = 1        'vertical front porch lines
  c_VGA_VS = 4        'vertical sync lines
  c_VGA_VB = 23       'vertical back porch lines
  c_VGA_HN = 0        'horizontal normal sync state (0|1)
  c_VGA_VN = 0        'vertical normal sync state (0|1)
  c_VGA_PR = 50       'pixel rate in MHz at 80MHz system clock (5MHz granularity)
  COLS = c_VGA_HP / 8
  ROWS = c_VGA_VP / 12
#endif
#ifdef KN001_002  ' VGA TEXT 1024x768, 57Hz, 128x64 characters, 8x12 ext. Font 0-255, 16/16 Color
CON  
  c_VGA_HP = 1024     'horizontal pixels
  c_VGA_VP = 768      'vertical pixels
  c_VGA_HF = 16       'horizontal front porch pixels
  c_VGA_HS = 96       'horizontal sync pixels
  c_VGA_HB = 176      'horizontal back porch pixels
  c_VGA_VF = 1        'vertical front porch lines
  c_VGA_VS = 3        'vertical sync lines
  c_VGA_VB = 28       'vertical back porch lines
  c_VGA_HN = 1        'horizontal normal sync state (0|1)
  c_VGA_VN = 1        'vertical normal sync state (0|1)
  c_VGA_PR = 60       'pixel rate in MHz at 80MHz system clock (5MHz granularity)
  COLS = c_VGA_HP / 8
  ROWS = c_VGA_VP / 12
#endif

#ifdef KN001
#1, c_VGA_SCANBUFF[128], c_VGA_SCANCODE[128*2-1+3], c_VGA_MAINCODE  'enumerate COG RAM usage

  c_VGA_MAIN_SIZE = $1F0 - c_VGA_MAINCODE                           'size of main program   
  c_VGA_HV_INACTIVE = (c_VGA_HN << 1 + c_VGA_VN) * $0101            'H,V inactive states

VAR
  long VGA_cog[2]


PUB s_VGA_START'(v_VGA_SCREENPTR, v_VGA_COLORPTR, v_VGA_CURSORPTR, v_VGA_SYNCPTR)| i, j
  return

PUB s_VGA_STOP
  return

DAT
    org                             'set origin to $000 for start of program
a_VGA                      
    long    1 << 9                  'd0 always resides here at $000, executes as NOP
    jmp   #a_VGA

#endif

#ifdef KN001_xxx_000 ' Zeichensatz Deutsch
a_VGA_FONT  long
' 8 x 12 font - characters 0..127
'
' Each long holds four scan lines of a single character. The longs are arranged into
' groups of 128 which represent all characters (0..127). There are three groups which
' each contain a vertical third of all characters. They are ordered top, middle, and
' bottom.
long  $0C080000,$30100000,$7E3C1800,$18181800,$81423C00,$99423C00,$8181FF00,$E7C3FF00  'top
long  $1E0E0602,$1C000000,$00000000,$00000000,$18181818,$18181818,$00000000,$18181818
long  $00000000,$18181818,$18181818,$18181818,$18181818,$00FFFF00,$CC993366,$66666666
long  $AA55AA55,$0F0F0F0F,$0F0F0F0F,$0F0F0F0F,$0F0F0F0F,$00000000,$00000000,$00000000
long  $00000000,$3C3C1800,$77666600,$7F363600,$667C1818,$46000000,$1B1B0E00,$1C181800
long  $0C183000,$180C0600,$66000000,$18000000,$00000000,$00000000,$00000000,$60400000
long  $73633E00,$1E181000,$66663C00,$60663C00,$3C383000,$06067E00,$060C3800,$63637F00
long  $66663C00,$66663C00,$1C000000,$00000000,$18306000,$00000000,$180C0600,$60663C00
long  $63673E00,$66663C00,$66663F00,$63663C00,$66361F00,$06467F00,$06467F00,$63663C00
long  $63636300,$18183C00,$30307800,$36666700,$06060F00,$7F776300,$67636300,$63361C00
long  $66663F00,$63361C00,$66663F00,$66663C00,$185A7E00,$66666600,$66666600,$63636300
long  $66666600,$66666600,$31637F00,$0C0C3C00,$03010000,$30303C00,$361C0800,$00000000
long  $0C000000,$00000000,$06060700,$00000000,$30303800,$00000000,$0C6C3800,$00000000
long  $06060700,$00181800,$00606000,$06060700,$18181E00,$00000000,$00000000,$00000000
long  $00000000,$00000000,$00000000,$00000000,$0C080000,$00000000,$00000000,$00000000
long  $00000000,$00000000,$00000000,$18187000,$18181800,$18180E00,$73DBCE00,$18180000

long  $080C7E7E,$10307E7E,$18181818,$7E181818,$81818181,$99BDBDBD,$81818181,$E7BD99BD  'middle
long  $1E3E7E3E,$1C3E3E3E,$30F0C000,$0C0F0300,$00C0F030,$00030F0C,$00FFFF00,$18181818
long  $18FFFF00,$00FFFF18,$18F8F818,$181F1F18,$18FFFF18,$00FFFF00,$CC993366,$66666666
long  $AA55AA55,$FFFF0F0F,$F0F00F0F,$0F0F0F0F,$00000F0F,$FFFF0000,$F0F00000,$0F0F0000
long  $00000000,$0018183C,$00000033,$7F363636,$66603C06,$0C183066,$337B5B0E,$0000000C
long  $0C060606,$18303030,$663CFF3C,$18187E18,$00000000,$00007E00,$00000000,$060C1830
long  $676F6B7B,$18181818,$0C183060,$60603860,$307F3336,$60603E06,$66663E06,$0C183060
long  $66763C6E,$60607C66,$1C00001C,$00001C1C,$180C060C,$007E007E,$18306030,$00181830
long  $033B7B7B,$66667E66,$66663E66,$63030303,$66666666,$06263E26,$06263E26,$63730303
long  $63637F63,$18181818,$33333030,$36361E36,$66460606,$63636B7F,$737B7F6F,$63636363
long  $06063E66,$7B636363,$66363E66,$66301C06,$18181818,$66666666,$66666666,$366B6B63
long  $663C183C,$18183C66,$43060C18,$0C0C0C0C,$30180C06,$30303030,$00000063,$00000000
long  $0030381C,$333E301E,$6666663E,$0606663C,$3333333E,$067E663C,$0C0C3E0C,$3333336E
long  $66666E36,$1818181C,$60606070,$361E3666,$18181818,$6B6B6B3F,$6666663E,$6666663C
long  $6666663B,$3333336E,$066E7637,$300C663C,$0C0C0C7E,$33333333,$66666666,$6B6B6363
long  $1C1C3663,$66666666,$0C30627E,$180C060C,$18181818,$18306030,$00000000,$0018187E

long  $00000000,$00000000,$00001818,$0000183C,$00003C42,$00003C42,$0000FF81,$0000FFC3  'bottom
long  $0002060E,$00000000,$18181818,$18181818,$00000000,$00000000,$00000000,$18181818
long  $18181818,$00000000,$18181818,$18181818,$18181818,$00FFFF00,$CC993366,$66666666
long  $AA55AA55,$FFFFFFFF,$F0F0F0F0,$0F0F0F0F,$00000000,$FFFFFFFF,$F0F0F0F0,$0F0F0F0F
long  $00000000,$00001818,$00000000,$00003636,$0018183E,$00006266,$00006E3B,$00000000
long  $00003018,$0000060C,$00000000,$00000000,$0C181C1C,$00000000,$00001C1C,$00000103
long  $00003E63,$00007E18,$00007E66,$00003C66,$00007830,$00003C66,$00003C66,$00000C0C
long  $00003C66,$00001C30,$0000001C,$0C181C1C,$00006030,$00000000,$0000060C,$00001818
long  $00003E07,$00006666,$00003F66,$00003C66,$00001F36,$00007F46,$00000F06,$00007C66
long  $00006363,$00003C18,$00001E33,$00006766,$00007F66,$00006363,$00006363,$00001C36
long  $00000F06,$00603C36,$00006766,$00003C66,$00003C18,$00003C66,$0000183C,$00003636
long  $00006666,$00003C18,$00007F63,$00003C0C,$00004060,$00003C30,$00000000,$FFFF0000
long  $00000000,$00006E33,$00003B66,$00003C66,$00006E33,$00003C66,$00001E0C,$1E33303E
long  $00006766,$00007E18,$3C666660,$00006766,$00007E18,$00006B6B,$00006666,$00003C66
long  $0F063E66,$78303E33,$00000F06,$00003C66,$0000386C,$00006E33,$0000183C,$00003636
long  $00006336,$1C30607C,$00007E46,$00007018,$00001818,$00000E18,$00000000,$0000007E
#endif